//
//  VankeSettlementListAPI.m
//  vanke
//
//  Created by xiaomi on 15/10/8.
//  Copyright © 2015年 gomore. All rights reserved.
//

#import "VankeSettlementListAPI.h"
#import "VankeConfig.h"
#import "VankeUtil.h"

@implementation VankeSettlementListAPI

@synthesize settleEquals = _settleEquals;
@synthesize confirmed = _confirmed;
@synthesize projectsIn = _projectsIn;
@synthesize shopNameOrCodeLike = _shopNameOrCodeLike;

-(void) route:(BeeMessage *)msg {
    if (self.sending)
    {
//        if (![self checkToQuery]) {
//            return;
//        }
        
//        [self http_get:@"/statement/query"].PARAM(@"settleEquals", self.settleEquals).PARAM(@"prjectsIn", [self.projectsIn componentsJoinedByString:@";"]).TIMEOUT(10);
        [self HTTP_GET:@"http://www.baidu.com"].TIMEOUT(10);
    }
    else if (self.succeed)
    {
        NSLog(@"response: %@", self.responseString);
        
//        self.serverResp = [StatementListResponse objectFromDictionary: self.responseJSONDictionary];
//        if (nil == self.serverResp)
//        {
//            self.failed = YES;
//            return;
//        }
        self.serverResp = [StatementListResponse fakeData];
    } else if (self.failed) {
        NSLog(@"response: %@", self.responseString);
        self.serverResp = [StatementListResponse objectFromDictionary: self.responseJSONDictionary];
    }
}

-(BOOL) checkToQuery {
    if ([VankeUtil isBlankString:self.settleEquals]) {
        [self setClientError: @"账期不能为空"];
        return NO;
    }
    
    if (nil == self.projectsIn || [self.projectsIn count] <= 0) {
        [self setClientError: @"项目列表不能为空"];
        return NO;
    }
    
    return YES;
}

@end

#pragma Paging

@implementation Paging

@synthesize page = _page;
@synthesize pageSize = _pageSize;
@synthesize pageCount = _pageCount;
@synthesize recordCount = _recordCount;

@end


#pragma SubjectItem

@implementation SubjectItem

@synthesize subject = _subject;
@synthesize beginDate = _beginDate;
@synthesize endDate = _endDate;
@synthesize direction = _direction;
@synthesize amount = _amount;
@synthesize remark = _remark;

-(NSString*) getPictureUrlOrDefault {
    //    if ([VankeUtil isBlankString:self.picture]) {
    return @"bill.png";
    //    } else {
    //        return [NSString stringWithFormat:@"%@/%@", VANKE_SERVER_MEDIA_BASE_URL, self.picture];
    //    }
}

-(NSString*) codeName {
    return [NSString stringWithFormat:@"%@%@", @"", _subject];
}

@end

#pragma  StatementSummary

@implementation StatementSummary

@synthesize contract = _contract;
@synthesize settle = _settle;
@synthesize amount = _amount;
@synthesize state = _state;
@synthesize items = _items;

CONVERT_PROPERTY_CLASS(items, SubjectItem)

-(BOOL) confirmed {
    return [@"confirmed" eq:_state];
}

@end

#pragma StatementListResponse

@implementation StatementListResponse

@synthesize amount = _amount;
@synthesize paging = _paging;
@synthesize records = _records;

CONVERT_PROPERTY_CLASS(records, StatementSummary)

-(BOOL) hasMore {
    return _paging && _paging.pageSize <= _paging.recordCount;
}

+(instancetype) fakeData {
    StatementListResponse *resp = [[StatementListResponse alloc] init];
    
    resp.amount = [NSNumber numberWithInt:1000];
    
    Paging *paging = [[Paging alloc] init];
    paging.page = [NSNumber numberWithInt:1];
    paging.pageSize = [NSNumber numberWithInt:10];
    paging.pageCount = [NSNumber numberWithInt:10];
    paging.recordCount = [NSNumber numberWithInt:99];
    resp.paging = paging;
    
    StatementSummary *summary = [[StatementSummary alloc] init];
    summary.contract = @"112233";
    summary.settle = @"2015-12-20";
    summary.amount = [NSNumber numberWithInt:1000];
    summary.state = @"confirmed";
    NSMutableArray *ary = [[NSMutableArray alloc] initWithCapacity:10];
    for( int i = 0; i < 10; ++i) {
        SubjectItem *item = [[SubjectItem alloc] init];
        item.subject = @"A01-01 星巴克";
        item.beginDate = @"2015-12-01";
        item.endDate = @"2015-12-30";
        item.direction = [NSNumber numberWithInt:0];
        item.amount = [NSNumber numberWithInt:104001];
        item.remark = @"有意见，不同意";
        [ary addObject:item];
    }
    summary.items = ary;
    
    NSMutableArray *ary2 = [[NSMutableArray alloc] initWithCapacity:1];
    [ary2 addObject:summary];
    resp.records = ary2;
    
    return resp;
}


@end
